// nvcc main.cpp kernels.cu -lglut lGLU
#include <cuda.h>
#include <cuda_runtime.h>
#include <stdio.h>
#include <GL/glut.h>
#include "kernels.h"
void changeSize(int w, int h) 
{
	float ratio = 1.0 * w / h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, w, h);
	gluOrtho2D(-1,1,-1,1);
	glMatrixMode(GL_MODELVIEW);
}
float px_cpu, py_cpu;
void renderScene(void) 
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glColor3f(1,1,1);
	glPointSize(5.0);
	glBegin(GL_POINTS);								// C4
		glVertex3f(px_cpu, py_cpu,0);
	glEnd();
	glutSwapBuffers();
}
void idleFunction(void)
{
	call_movepar(0.04);								// C2
	const char *symbol_px_gpu="px_gpu";				// C3
	const char *symbol_py_gpu="py_gpu";
    cudaMemcpyFromSymbol (&px_cpu, symbol_px_gpu, sizeof(float), 0, cudaMemcpyDeviceToHost);
    cudaMemcpyFromSymbol (&py_cpu, symbol_py_gpu, sizeof(float), 0, cudaMemcpyDeviceToHost);
	glutPostRedisplay();
}
int main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(320,320);
	glutCreateWindow("CUDA Hello World GFX");
	call_setParDevice(0,0.45);						// C1
	cudaThreadSynchronize();
	// register callbacks
	glutDisplayFunc(renderScene);
	glutReshapeFunc(changeSize);
	glutIdleFunc(idleFunction);
	// enter GLUT event processing cycle
	glutMainLoop();
}